<template>
<v-layout align-center justify-center row wrap color="#f8f8f8" display: flex>
    <v-flex md12 pa-1 >
        <!-- search for desktop -->
        <v-layout >
            <v-flex md11 align-center>
                <div class="font-size-24-bold">Invoices Management</div>
            </v-flex>
            <v-flex md1></v-flex>
            <v-flex md3 align-center py-3 v-if="!mobileView">
                <v-text-field color="#538795"
                    solo
                    light
                    label="search"
                    hide-details
                    v-model="searchAdmin"
                    append-icon="search"
                >
                </v-text-field>
            </v-flex>
        </v-layout>
        <!--  search for mobile -->
        <v-layout>
            <v-flex xs12 align-center py-3 v-if="mobileView">
                <v-text-field color="#538795"
                    solo
                    light
                    label="search"
                    hide-details
                    v-model="searchAdmin"
                    append-icon="search"
                >
                </v-text-field>
            </v-flex>
        </v-layout>
        <!-- table for desktop -->
    <div>
      <!-- <v-toolbar flat color="white"> -->
        <v-toolbar-title></v-toolbar-title>
        <!-- <v-divider
          class="mx-2"
          inset
          vertical
        ></v-divider> -->
        <v-spacer></v-spacer>
        <!-- edit dialog -->
        <v-dialog v-model="dialogEdit" max-width="800px" scrollable>
          <v-card max-height="600">
            <v-card-title>
              <span class="headline">Edit Excel</span><v-icon style="margin-left:10px; color:#538795;">mdi-pencil</v-icon>
            </v-card-title>
            <v-card-text height="400">
              <v-container style="height:400; padding-top:0px;">
                <v-layout wrap max-height="400">
                  <v-flex md5 >
                    <v-text-field
                      v-for="item in columnExcel.slice(0,7)"
                      :label="item.label"
                      v-model="item.value"
                      :key="item.ref"
                      color="#538795"
                    ></v-text-field>
                    <!-- <v-text-field
                    ref="editinv_date"
                    prepend-icon="mail"
                    v-model="editinv_date"
                    label="E-mail"
                    color="#538795"
                    ></v-text-field> -->
                    <!-- {{columnExcel}} -->
                  </v-flex>
                  <v-flex xs1></v-flex>
                  <v-flex md5 >
                    <v-text-field
                      v-for="item in columnExcel.slice(7,14)"
                      :label="item.label"
                      v-model="item.value"
                      :key="item.ref"
                      color="#538795"
                    ></v-text-field>
                    {{editMail}}
                    <!-- <v-text-field
                    ref="editinv_date"
                    prepend-icon="mail"
                    v-model="editinv_date"
                    label="E-mail"
                    color="#538795"
                    ></v-text-field> -->
                  </v-flex>
                </v-layout>
              </v-container>
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="black" flat @click="dialogEdit = false">Cancel</v-btn>
              <v-btn color="green darken-1" flat @click="edit">Save</v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
        <!-- delete dialog -->
        <v-dialog v-model="dialogConfirm" max-width="400px">
          <v-card>
            <v-card-title>
              <v-icon style="margin-right:10px; color:#538795;">mdi-delete</v-icon><span class="headline">Delete Admin</span>
            </v-card-title>
            <v-card-text>
              <v-container grid-list-md>
                <v-layout wrap>
                    <v-flex xs12 style="background-color:#FEE3E3; color:red;">
                      <v-icon color="red">mdi-alert</v-icon>
                      You may be deleting user data. After you delete this, it can't be recovered.
                    </v-flex>
                </v-layout>
              </v-container>
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="black" flat @click="dialogConfirm = false">Cancel</v-btn>
              <v-btn color="red darken-1" class="white--text" @click="deleteItem">Delete</v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
      <v-flex md12 pa-1>
        <v-data-table
            :headers="headers"
            :items="dataview"
            class="elevation-1"
            :search="searchAdmin"
            disable-initial-sort
            id="mytable"
        >
            <template v-slot:items="props">
              <tr style="cursor: pointer;">
                <td @click="openinvoicemodal(props.item.Invoice_no)" class="text-xs-left">{{ props.item.Invoice_no }}</td>
                <td @click="openinvoicemodal(props.item.Invoice_no)" class="text-xs-left">{{ props.item.DueDate }}</td>
                <td @click="openinvoicemodal(props.item.Invoice_no)" class="text-xs-center">{{ props.item.Customer_name }}</td>
                <td @click="openinvoicemodal(props.item.Invoice_no)" class="text-xs-right">{{ props.item.Vat_amount }}</td>
                <td @click="openinvoicemodal(props.item.Invoice_no)" class="text-xs-right">{{ props.item.Wht_amount }}</td>
                <td @click="openinvoicemodal(props.item.Invoice_no)" class="text-xs-right">{{ props.item.Amount_Inc_VAT }}</td>
                <td class="justify-center layout px-0">
                  <v-icon
                  small
                  color="#538795"
                  class="mr-2"

                  @click="editItem(props.item.Invoice_no)"
                  >
                  edit
                  </v-icon>
                  <v-icon
                  small
                  color="red"
                  @click="dialogDel(props.item.id)"
                  >
                  delete
                  </v-icon>
                </td>
              </tr>
            </template>
        </v-data-table>
        <!-- <p>{{editedItem}}</p> -->
      </v-flex>
    </div>
    </v-flex>
  <Invoicemodal />
</v-layout>
</template>
<script>
import { sync } from 'vuex-pathify'
import moment from 'moment'
import Invoicemodal from '@/components/Invoicemodal'
moment.locale('en')
export default {
  components: {
    Invoicemodal
  },
  data () {
    return {
      dialog: false,
      dialogEdit: false,
      dialogConfirm: false,
      addMail: '',
      editMail: '',
      currentId: {},
      delelteId: '',
      role2: 'Admin',
      searchAdmin: '',
      excelList: [],
      editinv_date: '',
      columnExcel: [
        { ref: 'editinv_no', value: this.editMail, label: 'Invoice_no', color: '#538795' },
        { ref: 'editinv_date', value: 'dd', label: 'Invoice_date', color: '#538795' },
        { ref: 'editdue_date', value: 'ss', label: 'DueDate', color: '#538795' },
        { ref: 'editstart_date', value: '', label: 'Start_date', color: '#538795' },
        { ref: 'editcus_id', value: '', label: 'Customer_id', color: '#538795' },
        { ref: 'editcus_tax', value: '', label: 'Customer_tax', color: '#538795' },
        { ref: 'editcus_name', value: '', label: 'Customer_name', color: '#538795' },
        { ref: 'editamount_exc_VAT', value: '', label: 'Amount_Exc_VAT', color: '#538795' },
        { ref: 'editvat_amount', value: '', label: 'Vat_amount', color: '#538795' },
        { ref: 'editamount_inc_VAT', value: '', label: 'Amount_Inc_VAT', color: '#538795' },
        { ref: 'editwht_rate', value: '', label: 'Wht_rate', color: '#538795' },
        { ref: 'editwht_amount', value: '', label: 'Wht_amount', color: '#538795' },
        { ref: 'editpay_amount', value: '', label: 'Pay_amount', color: '#538795' }
      ],
      headers: [
        { text: 'Invoice No.', align: 'left', sortable: false, value: 'Invoice_no' },
        // { text: 'Invoice Date', align: 'center', value: 'Invoice_date' },
        { text: 'Doc Date', align: 'left', value: 'DueDate' },
        // { text: 'Start Date', align: 'center', value: 'Start_date', sortable: false },
        // { text: 'Customer Id', align: 'center', value: 'Customer_id', sortable: false },
        { text: 'Customer Name', align: 'center', value: 'Customer_name', sortable: false },
        // { text: 'Amount Exc VAT', align: 'center', value: 'Amount_Exc_VAT', sortable: false },
        { text: 'VAT', align: 'right', value: 'Vat_amount', sortable: false },
        // { text: 'Amount Inc VAT', align: 'center', value: 'Amount_Inc_VAT', sortable: false },
        // { text: 'Wht Rate', align: 'center', value: 'Wht_rate', sortable: false },
        { text: 'WHT', align: 'right', value: 'Wht_amount', sortable: false },
        { text: 'Pay Amount', align: 'right', value: 'Pay_amount', sortable: false },
        { text: 'Action', align: 'center', value: 'action', sortable: false }
      ],
      editedItem: {
        email: '',
        role: ''
      },
      defaultItem: {
        email: '',
        role: 'admin'
      }
    }
  },
  methods: {
    openinvoicemodal (invoiceno) {
      this.currentinvoiceno = invoiceno
      this.invoicemodal = true
    },
    clearForm () {
      Object.keys(this.form).forEach(f => {
        this.$refs[f].reset()
      })
    },
    async checkField () {
      this.formHasErrors = false
      Object.keys(this.form).forEach(f => {
        if (!this.form[f]) this.formHasErrors = true
        this.dialogloader = false
        this.$refs[f].validate(true)
      })
    },
    handleView () {
      this.mobileView = window.innerWidth <= 990
    },
    async getmyexcel () {
      try {
        this.istableloading = true
        var { data } = await this.axios.get(`${process.env.VUE_APP_APIHOST}/upload_list`, {
          headers: {
            Authorization: this.$cookies.get('token')
          }
        })
        // console.log('admin_list: ', data)
        this.excelList = data.filter(d => d.status == 'Success')
        console.log(this.excelList)
        this.istableloading = false
      } catch (error) {
        this.istableloading = false
        console.log(error.message)
      }
    },
    editItem (invno) {
      this.currentId = { id: invno }
      this.editMail = this.currentId.id
      // this.role2 = this.currentId.role
      // console.log(this.currentId)
      this.dialogEdit = true
      // console.log(this.currentId.id)
      // this.currentId.length = 0
    },
    async dialogDel (item) {
      this.delelteId = item
      this.dialogConfirm = true
      // console.log(this.delelteId)
    },
    async deleteItem () {
      this.istableloading = true
      // this.delelteId = item
      // confirm('Are you sure you want to delete this email?')
      // alert('Are you sure you want to delete this email?')
      let { data } = await this.axios.post(`${process.env.VUE_APP_APIHOST}/del_admin`,
        {
          id: this.delelteId
        }, {
          headers: { Authorization: this.$cookies.get('token') }
        })
      window.location.reload()
      //  && this.excelList.splice(index, 1)
    },
    close () {
      this.clearForm()
      this.dialog = false
      setTimeout(() => {
        this.editedItem = Object.assign({}, this.defaultItem)
        this.editedIndex = -1
      }, 300)
    },
    async save () {
      this.istableloading = true
      await this.checkField()
      if (this.formHasErrors == false) {
        let { data } = await this.axios.post(`${process.env.VUE_APP_APIHOST}/add_admin`,
          {
            email: this.addMail,
            createBy: this.$cookies.get('username')
          }, {
            headers: { Authorization: this.$cookies.get('token') }
          })
        if (data === 'Success') {
          window.location.reload()
        } else {
          alert('This Email is taken. Please try another.')
        }
      }
    },
    async edit () {
      this.istableloading = true
      // console.log('before', this.email, this.role2)
      let { data } = await this.axios.post(`${process.env.VUE_APP_APIHOST}/edit_admin`,
        {
          id: this.currentId.id,
          email: this.editMail
        }, {
          headers: { Authorization: this.$cookies.get('token') }
        })
      // alert('Edit Success!')
      window.location.reload()
    },
    addCommas (nStr) {
      nStr += ''
      var x = nStr.split('.')
      var x1 = x[0]
      var x2 = x.length > 1 ? '.' + x[1] : ''
      var rgx = /(\d+)(\d{3})/
      while (rgx.test(x1)) {
        x1 = x1.replace(rgx, '$1' + ',' + '$2')
      }
      return x1 + x2
    }
  },
  created () {
    this.getmyexcel()
    this.handleView()
    window.addEventListener('resize', this.handleView)
  },
  computed: {
    invoicemodal: sync('invoicemodal'),
    currentinvoiceno: sync('currentinvoiceno'),
    form () {
      return {
        addmail: this.addMail
      }
    },
    dataview () {
      return this.excelList.map(data => {
        return {
          ...data,
          DueDate: moment(data.DueDate).format('D MMMM YYYY'),
          Vat_amount: this.addCommas(data.Vat_amount.toFixed(2)) + ' THB',
          Wht_amount: this.addCommas(data.Wht_amount.toFixed(2)) + ' THB',
          Amount_Inc_VAT: this.addCommas(data.Amount_Inc_VAT.toFixed(2)) + ' THB'
        }
      })
    }
  },
  watch: {
    dialog (val) {
      val || this.close()
    }
  }
}
</script>
